<template>
  <div>
    <header class="text-center">

      <img
        :src="cryptoData.url_image"
        style="
          max-width: 50px;
          margin-bottom: 30px;
          margin-right: 15px;
        "
      />
      <h1 class="display-4">{{ currencyMaj }}</h1>
    </header>

    <div class="text-center">

      <div class="card-deck text-center ">
        <div class="card col m-1">
          <div class="card-body">
            <h2 class="text-primary text-left" >Last price</h2>
            <h1   v-if="user==='USD'" >{{cryptoData.current_price_usd}} $</h1>
            <h1   v-else > {{cryptoData.current_price_eur}} €</h1>
          </div>
        </div>
        <div class="card col m-1">
          <div class="card-body">
            <h2 class="text-info text-left">24h change</h2>
            <h1>{{cryptoData.price_change_percentage_24h}} %</h1>
          </div>
        </div>
        <div class="card col m-1">
          <div class="card-body">
            <h2 class="text-success text-left">24h highest</h2>
            <h1   v-if="user==='USD'" >{{cryptoData.highest_price_usd}} $</h1>
            <h1   v-else > {{cryptoData.highest_price_eur}} €</h1>
          </div>
        </div>
        <div class="card col m-1">
          <div class="card-body">
            <h2 class="text-danger text-left">24h lowest</h2>
            <h1   v-if="user==='USD'" >{{cryptoData.lowest_price_usd}} $</h1>
            <h1   v-else > {{cryptoData.lowest_price_eur}} €</h1>
          </div>
        </div>
      </div>
    </div>
    <div>
      <h1 class="h1 mb-0">History</h1>
      <div class="separator mb-4"></div>
      <b-button-group size="sm">
        <b-button
          v-for="(btn, idx) in buttons"
          :key="idx"
          :pressed.sync="btn.state"
          variant="primary"
          @click="changeTime(btn.caption)"
        >
          {{ btn.caption }}
        </b-button>
      </b-button-group>
    </div>
    <div class="w-100 text-center">
      <apexchart
        v-if="month === true"
        width='90%'
        type="bar"
        :options="options"
        :series="series"
        class="m-auto"
      ></apexchart>
      <apexchart
        v-if="day === true"
        width="90%"
        type="bar"
        :options="options2"
        :series="series2"
        class="m-auto"
      ></apexchart>
      <apexchart
        v-if="hour === true"
        width="90%"
        type="bar"
        :options="options3"
        :series="series3"
        class="m-auto"
      ></apexchart>
  </div>
  </div>
</template>

<script>
import Vue from 'vue'
import { mapGetters, mapMutations } from 'vuex'
import VueApexCharts from 'vue-apexcharts'
import moment from 'moment'
Vue.component('apexchart', VueApexCharts)

export default {
  data() {
    return {
      user: '',
      month: true,
      day: false,
      hour: false,
      myToggle: false,
      buttons: [
        { caption: 'Daily', state: true },
        { caption: 'Hourly', state: false },
        { caption: 'Minute', state: false },
      ],
      currency: '',
      currencyMaj: '',
      history: [],
      cryptoData: {},
      history2: [],
      history3: [],
      date: [],
      value: [],
      date2: [],
      value2: [],
      date3: [],
      value3: [],
      options: {
        chart: {
          height: 350,
          type: 'line',
          zoom: {
            enabled: false,
          },
        },
        markers: {
          size: 0,
        },
        dataLabels: {
          enabled: false,
        },
        stroke: {
          show: true,
          curve: 'smooth',
          lineCap: 'butt',
          colors: undefined,
          width: 2,
          dashArray: 0,
        },
        xaxis: {
          categories: [],
        },
      },
      series: [
        {
          name: 'value',
          data: [],
        },
      ],
      options2: {
        chart: {
          height: 350,
          type: 'line',
          zoom: {
            enabled: false,
          },
        },
        stroke: {
          show: true,
          curve: 'smooth',
          lineCap: 'butt',
          colors: undefined,
          width: 2,
          dashArray: 0,
        },
        markers: {
          size: 0,
        },
        dataLabels: {
          enabled: false,
        },
        xaxis: {
          categories: [],
        },
      },
      series2: [
        {
          name: 'value',
          data: [],
        },
      ],
      options3: {
        chart: {
          height: 350,
          type: 'line',
          zoom: {
            enabled: false,
          },
        },
        stroke: {
          show: true,
          curve: 'smooth',
          lineCap: 'butt',
          colors: undefined,
          width: 2,
          dashArray: 0,
        },
        markers: {
          size: 0,
        },
        dataLabels: {
          enabled: false,
        },
        xaxis: {
          categories: [],
        },
      },
      series3: [
        {
          name: 'value',
          data: [],
        },
      ],
    }
  },
  methods: {
    updateChart() {
      var cur = '';
      if(this.user =="USD"){
        cur = '$';
      }else{
        cur = '€';
      }

      this.options = {
        ...this.options,
        ...{
          xaxis: {
            type: 'category',
            categories: this.date,
          },
          yaxis: {
            labels: {
            formatter: function (value) {
            return value + cur ;
            }
            },
          },
        },
      }

      this.series = [
        {
          name: 'Price',
          data: this.value,
        },
      ]

      this.options2 = {
        ...this.options2,
        ...{
          xaxis: {
            type: 'category',
            categories: this.date2,
          },
        },
      }

      this.series2 = [
        {
          name: 'Price',
          data: this.value2,
        },
      ]

      this.options3 = {
        ...this.options2,
        ...{
          xaxis: {
            type: 'category',
            categories: this.date3,
          },
        },
      }

      this.series3 = [
        {
          name: 'Price',
          data: this.value3,
        },
      ]
    },
    changeTime(time) {
      if (time === 'Daily') {
        this.buttons[0].state = true
        this.buttons[1].state = false
        this.buttons[2].state = false
        this.day = false
        this.hour = false
        this.month = true
      }
      if (time === 'Hourly') {
        this.buttons[0].state = false
        this.buttons[1].state = true
        this.buttons[2].state = false
        this.day = true
        this.hour = false
        this.month = false
      }
      if (time === 'Minute') {
        this.buttons[0].state = false
        this.buttons[1].state = false
        this.buttons[2].state = true
        this.day = false
        this.hour = true
        this.month = false
      }
    },
  },
  computed: {
    ...mapGetters({
      currentUser: 'currentUser',
    }),
  },
  async mounted() {
    await Vue.prototype.$http
      .get(`http://localhost:3000/api/users/${this.currentUser.id}`)
      .then((data) => (this.user = data.data.currency));

      await Vue.prototype.$http
        .get(`http://localhost:3000/api/cryptos/${this.$route.query.pid}`)
        .then((data) => (
        this.cryptoData = data.data
        ));

    this.currency = this.$route.query.id
    this.currencyMaj =
      this.currency.charAt(0).toUpperCase() + this.currency.slice(1)
    await Vue.prototype.$http
      .post(
        `http://localhost:3000/api/cryptos/${this.currency}/history/daily`,
        {
          currency: this.user,
        }
      )
      .then(
        (data) =>
          (this.history = data.data.prices.filter((value, idx) => idx < 120))
      )

    for (let i = 0; i < this.history.length; i++) {
      this.date[i] = moment(this.history[i][0]).format('DD/MM/YYYY')
    }
    for (let i = 0; i < this.history.length; i++) {
      this.value[i] = Math.round(this.history[i][1] * 100) / 100
    }

    await Vue.prototype.$http
      .post(
        `http://localhost:3000/api/cryptos/${this.currency}/history/hourly`,
        {
          currency: this.user,
        }
      )
      .then(
        (data) =>
          (this.history2 = data.data.prices.filter((value, idx) => idx < 120))
      )

    for (let i = 0; i < this.history2.length; i++) {
      this.date2[i] = moment(this.history2[i][0]).format('HH:MM')
    }
    for (let i = 0; i < this.history2.length; i++) {
      this.value2[i] = Math.round(this.history2[i][1] * 100) / 100
    }

    await Vue.prototype.$http
      .post(
        `http://localhost:3000/api/cryptos/${this.currency}/history/minute`,
        {
          currency: this.user,
        }
      )
      .then((data) => (this.history3 = data.data.prices))
    // console.log('history3', this.history3)

    for (let i = 0; i < this.history3.length; i++) {
      this.date3[i] = moment(this.history3[i][0]).format("hh:mm:ss")
    }
    for (let i = 0; i < this.history3.length; i++) {
      this.value3[i] = Math.round(this.history3[i][1] * 100) / 100
    }
    // console.log(this.date3)

    this.updateChart()
  },
}
</script>
